<?php
require_once 'dompdf/autoload.inc.php';
// reference the Dompdf namespace
use Dompdf\Dompdf;
include "includes/db.php";
include "includes/auth.php";
$msg="";
$currentDay = date("j");
$sd_id=$_GET['sd_id'];
$sd_name='';

$sd_profile_query = mysqli_query($con,"SELECT * FROM `sub_distributor` where sub_distributor_id='$sd_id'");
while($fetch_sd = mysqli_fetch_array($sd_profile_query)){
    $sd_name=$fetch_sd['name'];
    $sd_phone=$fetch_sd['phone'];
    $sd_acc_balance=$fetch_sd["sd_balance"];
}


if (isset($_POST["add_ledger"])) {
  
  $description=$con->real_escape_string($_POST["description"]);
  $ledger_type=$con->real_escape_string($_POST["ledger_type"]);
  $amount=$con->real_escape_string($_POST["amount"]);
  $ledger_date=$con->real_escape_string($_POST["ledger_date"]);

  $debit_amount=$credit_amount='';

  if ($ledger_type=='Debit') {
    $debit_amount=$amount;
    $credit_amount='';
  }
  elseif($ledger_type=='Credit'){
    $credit_amount=$amount;
    $debit_amount='';
  }
  
  
  $query="INSERT INTO `sd_ledger`(`sd_id`,`description`,`payment_type`, `debit_amount`, `credit_amount`, `ledger_date`) VALUES ('$sd_id','$description','$ledger_type','$debit_amount','$credit_amount','$ledger_date')";
  if ($con->query($query) === TRUE) {
            $msg .="<div class='alert alert-success'>Legder Record Has Been Added Successfully.</div>";
        } else {
             $msg .="Error: " . $query . "<br>" . $con->error;
        }      
}


if (isset($_POST["update_ledger"])) {
  
  $sd_ledger_id=$con->real_escape_string($_POST["sd_ledger_id"]);
  $description=$con->real_escape_string($_POST["description"]);
  $ledger_type=$con->real_escape_string($_POST["ledger_type"]);
  $amount=$con->real_escape_string($_POST["amount"]);
  $ledger_date=$con->real_escape_string($_POST["ledger_date"]);

  $debit_amount=$credit_amount='';

  if ($ledger_type=='Debit') {
    $debit_amount=$amount;
    $credit_amount='';
  }
  elseif($ledger_type=='Credit'){
    $credit_amount=$amount;
    $debit_amount='';
  }
  
  
  $query=" UPDATE `sd_ledger` SET 
    `description` = '$description', 
    `payment_type` = '$ledger_type', 
    `debit_amount` = '$debit_amount', 
    `credit_amount` = '$credit_amount', 
    `ledger_date` = '$ledger_date' 
    WHERE `sd_ledger_id` = '$sd_ledger_id'";
  if ($con->query($query) === TRUE) {
            $msg .="<div class='alert alert-success'>Legder Record Has Been Added Successfully.</div>";
        } else {
             $msg .="Error: " . $query . "<br>" . $con->error;
        }      
}



if (isset($_POST["export_ledger"])) {
   
  $rows=$products_area='';
  $formatted_date = date("D, d M y | h:i A");
  $date=date("Y/m/d");  

  $total_debit=0;
  $total_credit=0;

   $ledger_export_query = mysqli_query($con,"SELECT * FROM `sd_ledger` where sd_id='$sd_id'");
    while($fetch_data = mysqli_fetch_array($ledger_export_query)){
      $debit_amount=$fetch_data["debit_amount"];
      $credit_amount=$fetch_data["credit_amount"];
      $rows.='<tr class="item">
                      <td>'.$fetch_data['ledger_date'].'<br>'.$fetch_data['description'].'</td>
                      <td class="bg-danger">'.$debit_amount.'</td>
                      <td class="bg-success">'.$credit_amount.'</td>
                    </tr>';
      $total_debit =floatval($total_debit)+floatval($fetch_data['debit_amount']);
      $total_credit =floatval($total_credit)+floatval($fetch_data['credit_amount']);            
    } 




 $products_area.='
                <tr class="heading1">
                   <td>Date</td>
                   <td class="bg-danger">Debit Amount</td>
                   <td class="bg-success">Credit Amount</td>
                </tr>'.$rows;   


$content='<style>
         .invoice-box {
            margin: auto;
            border: 1px solid #eee;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.15);
            font-size: 12px;
            line-height: 20px;
            color: #555;
         }

         .invoice-box table {
            line-height: inherit;
            text-align: left;
            border-collapse: collapse;
         }

         .invoice-box table td {
            padding: 2px;
            vertical-align: top;
         }

         .invoice-box table tr td:nth-child(2) {
            text-align: left;
         }

         .invoice-box table tr.top table td {
            padding-bottom: 0px;
         }

         .invoice-box table tr.top table td.title {
            font-size: 20px;
            line-height: 45px;
            color: #333;
         }

         .invoice-box table tr.information table td {
            padding-bottom: 10px;
         }

         .invoice-box table tr.heading td {
            background: #716cb9;
            border-bottom: 1px solid #ddd;
            font-weight: bold;
            color: white;
            font-size:18px;
         }

         .heading1 {
            background: #e3e3e3;
            border-bottom: 1px solid #ddd;
            font-weight: bold;
            color: #3a3a3a;
            font-size: 16px;
         }

         .invoice-box table tr.details td {
            padding-bottom: 20px;
         }

         .invoice-box table tr.item td {
            border-bottom: 1px solid #eee;
         }

         .invoice-box table tr.item.last td {
            border-bottom: none;
         }

         .invoice-box table tr.total td:nth-child(2) {
            border-top: 2px solid #eee;
            font-weight: bold;
         }
         .bg-danger{
          background-color: rgb(247 210 213) !important;
         }
         .bg-success{
          background-color: rgb(168 223 197) !important;
         }

      </style>
      <div class="invoice-box">
      <p style="font-size:20px;font-weight:bold;padding: 0px;margin: 0px;color:#252161;text-align:center;padding-top:5px;font-family:sans-serif">Ledger Details </p>
         <table style="width:100%">
            <tr class="top">
               <td colspan="3">
                  <table style="width:100%">
                     <tr>
                        <td class="title">
                           <img src="https://mhadeed.com/mh-enterprises/assets/img/logo.png" alt="Company logo" style="max-width: 120px;" />
                        </td>
                        <td style="text-align: right;">
                           By: Ali Gujjar<br/>
                        </td>
                     </tr>
                  </table>
               </td>
            </tr>

            <tr class="information">
               <td colspan="3">
                  <table style="width:100%">
                     <tr>
                         <td>
                          <b>From:</b> <br /> 
                           M.Hadeed Traders<br />
                           Mudassar Bhatti Cotton Mill Near AMK Steel Mills <br />Opposite Maverick CNG Falsalabad <br />Bye Pass SheikhupuraK<br />
                           03218620288<br />
                        </td>

                        <td style="text-align: right;">
                          <b>SD Details:</b> <br />
                           Name: '.$sd_name.'.<br />
                           Phone: '.$sd_phone.'<br />
                           Cur. Balance: '.$sd_acc_balance.'<br />
                           
                        </td>
                     </tr>
                     
                  </table>
               </td>
            </tr>
            '.$products_area.' 
            <tr class="heading1">
                        <td style="text-align:right">Total</td>
                        <td class="bg-danger">'.number_format($total_debit,2).'</td>
                        <td class="bg-success">'.number_format($total_credit,2).'</td>
                     </tr>          
            </table>
            </div>';
            

          
            $date=date("Y-m-d");
            $sd_name = str_replace(' ', '_', $sd_name);
            $PDFFileN = $sd_name.$date.".pdf";
            

            // instantiate and use the dompdf class
            $dompdf = new Dompdf(array('enable_remote' => true));

            $dompdf->loadHtml("$content");

            // (Optional) Setup the paper size and orientation
            $dompdf->setPaper('A4', 'portrait');

            // Render the HTML as PDF
            $dompdf->render();

            $dompdf->stream($PDFFileN);


}



if (isset($_POST["delete"])) {
  $sd_ledger_id=$_POST['sd_ledger_id'];
  $query="DELETE FROM `sd_ledger` WHERE `sd_ledger_id` = '$sd_ledger_id'";
  if ($con->query($query) === TRUE) {
            $msg .="<div class='alert alert-success'>Ledger Item Has Been Deleted Successfully.</div>";
        } else {
             $msg .="Error: " . $query . "<br>" . $con->error;
        } 
}

 ?>


<?php
// Below is optional, remove if you have already connected to your database.
$mysqli = mysqli_connect('localhost', $username,$password,$database);

$quer="SELECT * FROM sd_ledger where sd_id='$sd_id' ORDER By sd_ledger_id desc"; 

$total_pages = $mysqli->query($quer)->num_rows;

// Check if the page number is specified and check if it's a number, if not return the default page number which is 1.
$page = isset($_GET['page']) && is_numeric($_GET['page']) ? $_GET['page'] : 1;

// Number of results to show on each page.
$num_results_on_page = 25;
 $que="SELECT * FROM sd_ledger where sd_id='$sd_id'  ORDER BY sd_ledger_id DESC LIMIT ?,?";


if ($stmt = $mysqli->prepare($que)) {
   // Calculate the page to get the results we need from our table.
   $calc_page = ($page - 1) * $num_results_on_page;
   $stmt->bind_param('ii', $calc_page, $num_results_on_page);
   $stmt->execute(); 
   // Get the results...
   $result = $stmt->get_result();
   ?>

<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta content="width=device-width, initial-scale=1.0" name="viewport">
 
  <title>Dashboard - Company Ledger</title>
  <?php include "includes/links.php"; ?>
  <style type="text/css">
    .bg-danger {
          --bs-bg-opacity: 1;
          background-color: rgb(247 210 213) !important;
      }
    .bg-success {
          --bs-bg-opacity: 1;
          background-color: rgb(168 223 197) !important;
      }
  </style>
</head>

<body>

  <?php include "includes/header.php"; ?>
  <?php include "includes/sidebar.php"; ?>


  <main id="main" class="main">

    <div class="pagetitle">
      <h1>Dashboard</h1>
      <nav>
        <ol class="breadcrumb">
          <li class="breadcrumb-item"><a href="dashboard.php">Home</a></li>
          <li class="breadcrumb-item active">Ledger List</li>
        </ol>
      </nav>
    </div><!-- End Page Title -->

    <section class="section dashboard">
      <div class="row">
        <!-- Left side columns -->
        <div class="col-lg-12">
          <form method="POST">
            <a href="#" class="btn btn-primary btn-sm mb-2"  data-bs-toggle="modal" data-bs-target="#add_ledger">Add Record</a>
            <button class="btn btn-sm btn-primary mb-1" name="export_ledger" type="POST"><i class="bi bi-file-earmark-pdf"></i> Ledger</button>
          </form>

          <div class="card">
            <div class="card-body">
              <h5 class="card-title"><?php echo $sd_name."'s"; ?> Ledger</h5>
             
              <?php if(isset($msg)){ echo $msg; } ?>
              <!-- No Labels Form -->
                <div class="col-md-12">
                  <table class="table datatable table-striped">
                <thead>
                  <tr>
                    <th>Date</th>
                    <th class="bg-danger">Debit</th>
                    <th class="bg-success">Credit</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>
                   <?php 
                      $total_debit=0;
                      $total_credit=0;
                   while ($fetch = $result->fetch_assoc()):
                     $total_debit1=$fetch["debit_amount"];
                     $total_debit=floatval($total_debit1)+floatval($total_debit);
                     $total_credit1=$fetch["credit_amount"];
                     $total_credit=floatval($total_credit1)+floatval($total_credit); 

                    ?>
                  <tr>
                    <td><?php
$date = $fetch["ledger_date"];
$formatted_date = date("D, d M Y", strtotime($date));
echo $formatted_date;
?>
<br/><small><?php echo $fetch["description"]; ?></small></td>
                    <td class="bg-danger"><?php echo number_format(floatval($fetch["debit_amount"]),2); ?></td>
                    <td class="bg-success"><?php echo number_format(floatval($fetch["credit_amount"]),2); ?></td>
                    <td>
                     <!-- <button class="btn btn-primary btn-sm"  data-bs-toggle="modal" data-bs-target="#edit_modal<?php echo $fetch["sd_ledger_id"]; ?>"><i class="ri-edit-box-line"></i></button>-->
                     <a href="#" class="btn btn-primary btn-sm"  data-bs-toggle="modal" data-bs-target="#edit_modal<?php echo $fetch["sd_ledger_id"]; ?>"><i class="ri-edit-box-line"></i></a>
                      <button class="btn btn-danger btn-sm"  data-bs-toggle="modal" data-bs-target="#delete_modal<?php echo $fetch["sd_ledger_id"]; ?>"><i class="ri-delete-bin-2-fill"></i></button>
                    </td>            

              <div class="modal fade" id="delete_modal<?php echo $fetch["sd_ledger_id"]; ?>" tabindex="-1">
                <div class="modal-dialog modal-md">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title">Delete Record</h5>
                      <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                      <form method="POST">
                        <div class="row">
                      <div class="col-md-12">
                        <input type="hidden" name="sd_ledger_id" value="<?php echo $fetch["sd_ledger_id"]; ?>">
                        <p>Do you want to delete this ledger record?</p>
                      </div>
                      </div>
                    </div>
                    <div class="modal-footer">
                      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                      <button type="submit" class="btn btn-danger" name="delete">Yes Delete</button>
                    </div>
                    </form>
                  </div>
                </div>
              </div><!-- End Extra Large Modal-->                  



              <div class="modal fade" id="edit_modal<?php echo $fetch["sd_ledger_id"]; ?>" tabindex="-1">
                <div class="modal-dialog modal-xl">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title"><?php echo $sd_name."'s" ?> Ledger</h5>
                      <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                      <form method="POST">
                        <div class="row">
                          <input type="hidden" name="sd_ledger_id" value="<?php echo $fetch["sd_ledger_id"]; ?>">
                          <div class="col-md-4">
                            <label for="ledger_type" class="form-label">Payment Type:</label>
                            <select class="form-select" id="ledger_type"  name="ledger_type" required>
                              <option value="" selected disabled>Select Any Payment Type</option>
                              <option value="Debit" <?php if($fetch["payment_type"]=='Debit'){echo "selected";} ?>>Debit</option>
                              <option value="Credit" <?php if($fetch["payment_type"]=='Credit'){echo "selected";} ?>>Credit</option>
                            </select>
                          </div>                            
                          <div class="col-md-4">
                              <label for="Amount" class="form-label">Amount:</label>
                              <input type="text" class="form-control" id="Amount" name="amount" value="<?php if($fetch["payment_type"]=='Debit'){echo $fetch["debit_amount"];} elseif($fetch["payment_type"]=='Credit'){echo $fetch["credit_amount"];} ?>">
                          </div>
                          <div class="col-md-4">
                            <label for="date" class="form-label">Date:</label>
                            <input type="date" class="form-control" name="ledger_date" value="<?php echo date('Y-m-d'); ?>" value="<?php echo $fetch["date_time"]; ?>">
                          </div>
                          <div class="col-md-12">               
                              <label for="description" class="form-label">Description:</label>
                              <textarea class="form-control" rows="3" name="description" id="description" spellcheck="false"><?php echo $fetch["description"]; ?></textarea>
                          </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                      <button type="submit" class="btn btn-primary" name="update_ledger">Update Record</button>
                    </div>
                    </form>
                  </div>
                </div>
              </div><!-- End Extra Large Modal-->  

                  </tr>
                  <?php endwhile; ?>               
                </tbody>
                <tfoot>
                  <tr>
                    <td colspan="1" style="text-align:right;font-weight:bold;">Total:</td>
                    <td class="bg-danger" style="font-weight:bold;"><?php echo number_format($total_debit,2); ?></td>
                    <td class="bg-success" style="font-weight:bold;"><?php echo number_format($total_credit,2); ?></td>
                    <td></td>
                  </tr>  
                </tfoot>
              </table>
                </div> 
<div class="dataTable-bottom">
         <?php if (ceil($total_pages / $num_results_on_page) > 0): ?>
        
         <ul class="news">
            <?php if ($page > 1): ?>
            <li class="prev"><a href="sales_list.php?page=<?php echo $page-1 ?>">Prev</a></li>
            <?php endif; ?>

            <?php if ($page > 3): ?>
            <li class="start"><a href="sales_list.php?page=1">1</a></li>
            <li class="dots">...</li>
            <?php endif; ?>

            <?php if ($page-2 > 0): ?><li class="page"><a href="sales_list.php?page=<?php echo $page-2 ?>"><?php echo $page-2 ?></a></li><?php endif; ?>
            <?php if ($page-1 > 0): ?><li class="page"><a href="sales_list.php?page=<?php echo $page-1 ?>"><?php echo $page-1 ?></a></li><?php endif; ?>

            <li class="currentpage"><a href="sales_list.php?page=<?php echo $page ?>"><?php echo $page ?></a></li>

            <?php if ($page+1 < ceil($total_pages / $num_results_on_page)+1): ?><li class="page"><a href="sales_list.php?page=<?php echo $page+1 ?>"><?php echo $page+1 ?></a></li><?php endif; ?>
            <?php if ($page+2 < ceil($total_pages / $num_results_on_page)+1): ?><li class="page"><a href="sales_list.php?page=<?php echo $page+2 ?>"><?php echo $page+2 ?></a></li><?php endif; ?>

            <?php if ($page < ceil($total_pages / $num_results_on_page)-2): ?>
            <li class="dots">...</li>
            <li class="end"><a href="sales_list.php?page=<?php echo ceil($total_pages / $num_results_on_page) ?>"><?php echo ceil($total_pages / $num_results_on_page) ?></a></li>
            <?php endif; ?>

            <?php if ($page < ceil($total_pages / $num_results_on_page)): ?>
            <li class="next"><a href="sales_list.php?page=<?php echo $page+1 ?>">Next</a></li>
            <?php endif; ?>
         </ul>
         <?php endif; ?>
                              </div>                             
            </div>
          </div>
        </div><!-- End Left side columns -->
       

      </div>
    </section>



              <div class="modal fade" id="add_ledger" tabindex="-1">
                <div class="modal-dialog modal-xl">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title">Company Ledger</h5>
                      <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <div class="modal-body">
                      <form method="POST">
                        <div class="row">
                          <div class="col-md-4">
                            <label for="ledger_type" class="form-label">Payment Type:</label>
                            <select class="form-select" id="ledger_type"  name="ledger_type" required>
                              <option value="" selected disabled>Select Any Payment Type</option>
                              <option value="Debit">Debit</option>
                              <option value="Credit">Credit</option>
                            </select>
                          </div>                            
                          <div class="col-md-4">
                              <label for="Amount" class="form-label">Amount:</label>
                              <input type="text" class="form-control" id="Amount" name="amount">
                          </div>
                          <div class="col-md-4">
                            <label for="date" class="form-label">Date:</label>
                            <input type="date" class="form-control" name="ledger_date" value="<?php echo date('Y-m-d'); ?>">
                          </div>
                          <div class="col-md-12">               
                              <label for="description" class="form-label">Description:</label>
                              <textarea class="form-control" rows="3" name="description" id="description" spellcheck="false"></textarea>
                          </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                      <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                      <button type="submit" class="btn btn-primary" name="add_ledger">Add Record</button>
                    </div>
                    </form>
                  </div>
                </div>
              </div><!-- End Extra Large Modal-->  

  </main><!-- End #main -->

  <?php include "includes/footer.php"; ?>

  <?php include "includes/scripts.php"; ?>
  <style>        
        .news {
            list-style-type: none;
            padding: 10px 0;
            display: inline-flex;
            justify-content: space-between;
            box-sizing: border-box;
         }
         .news li {
            box-sizing: border-box;
            padding-right: 10px;
         }
         .news li a {
            box-sizing: border-box;
            background-color: #e2e6e6;
            padding: 8px;
            text-decoration: none;
            font-size: 12px;
            font-weight: bold;
            color: #616872;
            border-radius: 4px;
         }
         .news li a:hover {
            background-color: #d4dada;
         }
         .news .next a, .news .prev a {
            text-transform: uppercase;
            font-size: 12px;
         }
         .news .currentpage a {
            background-color: #518acb;
            color: #fff;
         }
         .news .currentpage a:hover {
            background-color: #518acb;
         }
         </style>
         <script type="text/javascript">          
             const datatables = select('.datatable', true)
              datatables.forEach(datatable => {
                new simpleDatatables.DataTable(datatable, {
                  perPageSelect: [5, 10, 15, ["All", -1]],
                  "paging": false,
                  columns: [{
                      select: 2,
                      sortSequence: ["desc", "asc"]
                    },
                    {
                      select: 3,
                      sortSequence: ["desc"]
                    },
                    {
                      select: 4,
                      cellClass: "green",
                      headerClass: "red"
                    }
                  ]
                });
              })
         </script>
</body>

</html>
<?php
   $stmt->close();
}
?>