<?php 
include "includes/db.php";
include "includes/auth.php";
$statsday='';
if (isset($_POST['daysval'])) {
  $currentDay=$_POST['daysval'];
  $statsday= $currentDay;
}
else{
$currentDay = date("j");   
}

 ?>
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta content="width=device-width, initial-scale=1.0" name="viewport">

  <title>Dashboard - M hadeed</title>
  <?php include "includes/links.php"; ?>
<style type="text/css">
    .dashboard .info-card h6 {
    font-size: 18px;
    color: #012970;
    font-weight: 700;
    margin: 0;
    padding: 0;
}
  </style>
</head>

<body>

  <?php include "includes/header.php"; ?>
  <?php include "includes/sidebar.php"; ?>


  <main id="main" class="main">

    <div class="pagetitle">
      <h1>Dashboard</h1>
      <nav>
        <ol class="breadcrumb">
          <li class="breadcrumb-item"><a href="index.html">Home</a></li>
          <li class="breadcrumb-item active">Dashboard</li>
        </ol>
      </nav>
    </div><!-- End Page Title -->

    <section class="section dashboard">
      <div class="row">

        <!-- Left side columns -->
        <div class="col-lg-4">
          <div class="row"> 
            <!-- Sales Card -->
            <div class="col-xx-12 col-md-12">
              <div class="card info-card sales-card">
                <div class="card-body">
                  <h5 class="card-title">Total Balance <span>| SD's Balance</span></h5>

                  <div class="d-flex align-items-center">
                    <div class="card-icon rounded-circle d-flex align-items-center justify-content-center" style="color: #0d6efd;background: #0d6efd2e;">
                      <i class="bi bi-people"></i>
                    </div>
                    <div class="ps-3">
                      <h6>
                        <?php
                              // Define the query to calculate the total debit and credit amounts
                              $query = "SELECT 
                                          SUM(CAST(debit_amount AS DECIMAL(10,0))) AS total_debit_amount, 
                                          SUM(CAST(credit_amount AS DECIMAL(10,0))) AS total_credit_amount 
                                        FROM `sd_ledger`";

                              // Execute the query
                              $result = mysqli_query($con, $query);

                              // Fetch the result
                              if ($data = mysqli_fetch_assoc($result)) {
                                  // Retrieve the total debit and credit amounts
                                  $total_debit_amount = $data['total_debit_amount'];
                                  $total_credit_amount = $data['total_credit_amount'];

                                  // Calculate the balance
                                  $balance = $total_debit_amount - $total_credit_amount;

                                  // Output the balance
                                  echo  number_format($balance);
                              } else {
                                  // Handle the case when no data is retrieved
                                  echo "Error: Unable to fetch data.";
                              }
                          ?>
 
                      </h6>
                      <a href="distributors_list.php"><span class="text-success small pt-1 fw-bold">View Details</span></a>

                    </div>
                  </div>
                </div>

              </div>
            </div><!-- End Sales Card -->

            <!-- Ledger -->
            <div class="col-xx-6 col-md-12">
              <div class="card info-card customers-card">
                <div class="card-body">
                  <h5 class="card-title">GT Ledger <br/><span>  <span class="text-danger">Total Debit: <?php
                            $result=mysqli_query($con,"SELECT SUM(CAST(debit_amount AS DECIMAL(10,2))) AS total_debit_amount FROM `ledger`");
                            $data=mysqli_fetch_assoc($result);
                             $total_debit_amount=$data['total_debit_amount']; 
                            echo number_format($total_debit_amount,2);
                                                  ?></span>  |  <span class="text-success">Total Credit: <?php
                            $result=mysqli_query($con,"SELECT SUM(CAST(credit_amount AS DECIMAL(10,2))) AS total_credit_amount FROM `ledger`");
                            $data=mysqli_fetch_assoc($result);
                             $total_credit_amount=$data['total_credit_amount']; 
                            echo number_format($total_credit_amount,2);
                                                  ?></span> </span></h5>

                  <div class="d-flex align-items-center">
                    <div class="card-icon rounded-circle d-flex align-items-center justify-content-center" style="color: #5a75d7;background: #b5c2f1d9">
                      <i class="bi bi-newspaper"></i>
                    </div>
                    <div class="ps-3">
                      <?php $balance=$total_debit_amount-$total_credit_amount;
                          if ($balance>=0) {
                            echo '<h6 class="text-success">'.number_format($balance,2).'</h6>';
                          }
                          else{
                            echo '<h6 class="text-danger">'.number_format($balance,2).'</h6>';
                          }
                         ?>                                                                              
                     <a href="comapny_ledger.php"><span class="text-success small pt-1 fw-bold">View Details</span></a>
                    </div>
                  </div>

                </div>
              </div>
            </div><!-- End Expenses -->

            <!-- Ledger -->
            <div class="col-xx-6 col-md-12">
              <div class="card info-card customers-card">
                <div class="card-body">
                  <h5 class="card-title">HUB Ledger <br/><span>  <span class="text-danger">Total Debit: <?php
                            $result=mysqli_query($con,"SELECT SUM(CAST(debit_amount AS DECIMAL(10,2))) AS total_debit_amount FROM `hub_ledger`");
                            $data=mysqli_fetch_assoc($result);
                             $total_debit_amount=$data['total_debit_amount']; 
                            echo number_format($total_debit_amount,2);
                                                  ?></span>  |  <span class="text-success">Total Credit: <?php
                            $result=mysqli_query($con,"SELECT SUM(CAST(credit_amount AS DECIMAL(10,2))) AS total_credit_amount FROM `hub_ledger`");
                            $data=mysqli_fetch_assoc($result);
                             $total_credit_amount=$data['total_credit_amount']; 
                            echo number_format($total_credit_amount,2);
                                                  ?></span> </span></h5>

                  <div class="d-flex align-items-center">
                    <div class="card-icon rounded-circle d-flex align-items-center justify-content-center" style="color: #5a75d7;background: #b5c2f1d9">
                      <i class="bi bi-newspaper"></i>
                    </div>
                    <div class="ps-3">
                      <?php $balance=$total_debit_amount-$total_credit_amount;
                          if ($balance>=0) {
                            echo '<h6 class="text-success">'.number_format($balance,2).'</h6>';
                          }
                          else{
                            echo '<h6 class="text-danger">'.number_format($balance,2).'</h6>';
                          }
                         ?>                                                                              
                     <a href="hub_ledger.php"><span class="text-success small pt-1 fw-bold">View Details</span></a>
                    </div>
                  </div>

                </div>
              </div>
            </div><!-- End Expenses -->
            <div class="col-xx-12 col-md-12">
              <div class="card info-card sales-card">
                <div class="card-body">
                  <h5 class="card-title">Total Debit </h5>

                  <div class="d-flex align-items-center">
                    <div class="card-icon rounded-circle d-flex align-items-center justify-content-center" style="color: #0d6efd;background: #0d6efd2e;">
                      <i class="bi bi-people"></i>
                    </div>
                    <div class="ps-3">
                      <h6>
                        <?php
                              // Define the query to calculate the total debit and credit amounts
                              $query = "SELECT 
                                          SUM(CAST(debit_amount AS DECIMAL(10,0))) AS total_debit_amount, 
                                          SUM(CAST(credit_amount AS DECIMAL(10,0))) AS total_credit_amount 
                                        FROM `sd_ledger`";

                              // Execute the query
                              $result = mysqli_query($con, $query);

                              // Fetch the result
                              if ($data = mysqli_fetch_assoc($result)) {
                                  // Retrieve the total debit and credit amounts
                                  $total_debit_amount = $data['total_debit_amount'];

                                  // Output the balance
                                  echo  number_format($total_debit_amount);
                              } else {
                                  // Handle the case when no data is retrieved
                                  echo "Error: Unable to fetch data.";
                              }
                          ?>
 
                      </h6>
                      <a href="distributors_list.php"><span class="text-success small pt-1 fw-bold">View Details</span></a>

                    </div>
                  </div>
                </div>

              </div>
            </div><!-- End Sales Card -->

            <div class="col-xx-12 col-md-12">
              <div class="card info-card sales-card">
                <div class="card-body">
                  <h5 class="card-title">Total Credit</h5>

                  <div class="d-flex align-items-center">
                    <div class="card-icon rounded-circle d-flex align-items-center justify-content-center" style="color: #0d6efd;background: #0d6efd2e;">
                      <i class="bi bi-people"></i>
                    </div>
                    <div class="ps-3">
                      <h6>
                        <?php
                              // Define the query to calculate the total debit and credit amounts
                              $query = "SELECT 
                                          SUM(CAST(debit_amount AS DECIMAL(10,0))) AS total_debit_amount, 
                                          SUM(CAST(credit_amount AS DECIMAL(10,0))) AS total_credit_amount 
                                        FROM `sd_ledger`";

                              // Execute the query
                              $result = mysqli_query($con, $query);

                              // Fetch the result
                              if ($data = mysqli_fetch_assoc($result)) {
                                  // Retrieve the total debit and credit amounts
                                  $total_debit_amount = $data['total_debit_amount'];
                                  $total_credit_amount = $data['total_credit_amount'];

                                  // Output the balance
                                  echo  number_format($total_credit_amount);
                              } else {
                                  // Handle the case when no data is retrieved
                                  echo "Error: Unable to fetch data.";
                              }
                          ?>
 
                      </h6>
                      <a href="distributors_list.php"><span class="text-success small pt-1 fw-bold">View Details</span></a>

                    </div>
                  </div>
                </div>

              </div>
            </div><!-- End Sales Card -->
  
          </div>
        </div><!-- End Left side columns -->

        <!-- Right side columns -->
        <div class="col-lg-8">

          <!-- Recent Activity -->
          <div class="card">
            <div class="card-body">
              <h5 class="card-title">SD's Overview</h5>
              <table class="table datatable table-striped">
                <thead>
                  <tr>
                    <th  style="font-size:15px !important;width: 35%;">Name</th>
                    <th  style="font-size:15px !important;">Balance</th>
                  </tr>
                </thead>
                <tbody>
                  <?php
                        $sd_profile_query = mysqli_query($con,"SELECT * FROM `sub_distributor`");
                        while($fetch_sd = mysqli_fetch_array($sd_profile_query)){
                    ?>
                  <tr>
                    <td style="font-size:14px"><a href="sd_ledger.php?sd_id=<?php echo $fetch_sd['sub_distributor_id']; ?>"><?php echo $fetch_sd["name"]; ?></a></td>
                     <td  style="font-size:14px">
                        <?php $sdID=$fetch_sd["sub_distributor_id"];?>
                          <?php
                              // Define the query to calculate the total debit and credit amounts
                              $query = "SELECT 
                                          SUM(CAST(debit_amount AS DECIMAL(10,0))) AS total_debit_amount, 
                                          SUM(CAST(credit_amount AS DECIMAL(10,0))) AS total_credit_amount 
                                        FROM `sd_ledger`  where sd_id='$sdID'";

                              // Execute the query
                              $result = mysqli_query($con, $query);

                              // Fetch the result
                              if ($data = mysqli_fetch_assoc($result)) {
                                  // Retrieve the total debit and credit amounts
                                  $total_debit_amount = $data['total_debit_amount'];
                                  $total_credit_amount = $data['total_credit_amount'];

                                  // Calculate the balance
                                  $balance = $total_debit_amount - $total_credit_amount;

                                  // Output the balance
                                  echo number_format($balance);
                              } else {
                                  // Handle the case when no data is retrieved
                                  echo "Error: Unable to fetch data.";
                              }
                          ?>

                      </td>
                  </tr>  
                  <?php } ?>
                 </tbody>
                 </table> 

             

            </div>
          </div><!-- End Recent Activity -->
          
        </div><!-- End Right side columns -->

      </div>
    </section>

  </main><!-- End #main -->

  <?php include "includes/footer.php"; ?>

  <?php include "includes/scripts.php"; ?>

</body>

</html>